import type { EditorView } from 'codemirror';
import type { SimpleChange, EditorFacade } from 'collaborative-editor';
export declare class CodemirrorEditorFacade implements EditorFacade {
    protected readonly editor: EditorView;
    onchange?: (changes: SimpleChange[] | void) => void;
    onselection?: () => void;
    private disposed;
    private d0;
    private d1;
    constructor(editor: EditorView);
    get(): string;
    getLength(): number;
    set(text: string): void;
    ins(from: number, insert: string): void;
    del(from: number, length: number): void;
    getSelection(): [number, number, -1 | 0 | 1] | null;
    setSelection(start: number, end: number, direction: -1 | 0 | 1): void;
    dispose(): void;
}
